Redmine - Defect #36814

Can't login in after upgrading to rev. 21486
2022-03-21 10:11 - ChunChang (Nagaharu) Lo

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version:

Resolution: Cant reproduce Affected version:

Description

Hello,

| previously enabled 2fa with Google Authenticator and it worked smoothly.
After upgrading to rev.21486 | can no longer log in with the ga generated code.
The error message is "Invalid or outdated code".

How can | get rid of this?

Is there a way to disable 2fa without logging into Redmine?

thanks.

History

#1 - 2022-03-21 12:53 - Go MAEDA

| cannot reproduce the issue for now.

You can forcefully disable two-factor authentication if you can access the console of your Redmine server. Please follow the steps below:
Go go the installation directory of Redmine and start a Rails console.

cd path/to/redmine

bin/rails c¢ -e production

Enter the following lines in the Rails console. The example below disables two-factor authentication for the user ‘jsmith'.

user = User.find_by(login: 'jsmith')

require 'redmine/twofa/base’

twofa = Redmine::Twofa::Base.new(user)

twofa.destroy_pairing_without_verify!
exit

#2 - 2022-03-21 13:34 - ChunChang (Nagaharu) Lo
- File 2022-03-21_20-22-07.png added

Hello,

The code snippet works.

After disabling 2fa authentication for my account, it ask me to set it up again.
(I enabled this option for administrators when | tried to translate label_required_administrators, see #36606).

After | scanned the QR code in Google Authenticator and enter code shown in GA, it won't accept the code.
So, it seems that | need to disable this setting too.

Thanks in advance.
https://www.redmine.org/issues/36606

2022-03-21_20-22-07.png

#3 - 2022-03-21 14:07 - ChunChang (Nagaharu) Lo
Hi,
| figured it out.

$ mysgl -u myredmineuser -p

Enter password: myredminepassword

MariaDB [(none)]> use redmine

MariaDB [redmine]> update settings set value = 0 where name = 'twofa’;

| can login to my Redmine site again. :)

It is very strange that the 2fa setting page won't accept any code from Google Authenticator & Authy.
#4 - 2022-03-22 05:31 - Go MAEDA

ChunChang Lo wrote:

It is very strange that the 2fa setting page won't accept any code from Google Authenticator & Authy.

Are the clocks of your devices correct?
#5 - 2022-03-22 07:09 - ChunChang (Nagaharu) Lo
Go MAEDA wrote:

Are the clocks of your devices correct?

yes, the system time (iphone & pc) is the same. (ntp to the same timezone, Taipei UTC+8).
just tried again, and both google authenticator & authy are failed (the 2fa settings page doesn't accept codes from the app).
the error message is the same as '2022-03-21_20-22-07.png'.
BTW, the redmine server uses UTC & all admin accounts uses Taipei UTC+8 in the account's preferences.
#6 - 2022-03-24 04:32 - ChunChang (Nagaharu) Lo
- File 2022-03-24_11-28-40.png added
Strangely, 2fa can be enabled again after updating to rev.21497.
2022-03-24_11-28-40.png
#7 - 2022-07-04 15:30 - Go MAEDA

- Status changed from New to Closed

- Resolution set to Cant reproduce

#8 - 2022-07-18 11:54 - Jan Catrysse

It seems | have the same issue, | am on 4.2.3-stable.

I never had any issues, and now it seems people cannot longer activate 2FA: Code is invalid or outdated.

| observe it DOES work when 2FA is optional and users are using the account settings. If 2FA is required, and users get the forced 2FA prompt, it
doesn't work.

| also notice, it does seem to work on my test environment (other servers, same Redmine version). ROTP gem is 6.2.0, other gems are the same
version.

Both servers are on CEST and time synced. (Could DST play a role? We activated most accounts before summer time)

Could someone point me in a direction?

#9 - 2022-07-18 12:28 - Jan Catrysse

Correction:
The behavior on production seems to be the same for manual or forced 2FA activation.

This morning, multiple users were unable to activate 2FA, and now it only blocks from time to time.
This resembles a time sync issue... but all devices / servers are synchronized perfectly. Timezone is CEST (Belgium)

| tried again on my test environment, same behavior. The code is not working from time to time... but independently of the moment | use the code
(beginning, middle or end of the 30 second timeframe)
Could this be a Google Authenticator issue?

#10 - 2022-11-19 21:02 - Jangwon Han
- File 2fa.PNG added

Looks like reusing the 2fa scheme is causing the issue.

I made a change like below to resolve the issue. (redmine/app/controllers/application_controller.rb)

2fa2.PNG

Please make sure that you reboot your redmine server after the change.

Thanks.

#11 - 2022-11-19 21:19 - Jangwon Han
- File 2fa2.PNG added
